/*
 Copyright 1995-2013 Esri

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.

 For additional information, contact:
 Environmental Systems Research Institute, Inc.
 Attn: Contracts Dept
 380 New York Street
 Redlands, California, USA 92373

 email: contracts@esri.com
 */


package com.esri.core.geometry;

/**
 * A runtime exception raised when a geometry related exception occurs.
 */
public class GeometryException extends RuntimeException {

	private static final long serialVersionUID = 1L;
	/**
	 * The internal code for geometry exception.
	 */
	public int internalCode;

	/**
	 * Constructs a Geometry Exception with the given error string/message.
	 * 
	 * @param str
	 *            - The error string.
	 */
	GeometryException(String str) {
		super(str);
		internalCode = 0;
	}

	GeometryException(String str, int sgCode) {
		super(str);
		internalCode = sgCode;
	}

}
